<template>
  <div>
    <Row>
      <!--查询-->
      <Col span="24" />
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="70"
        class="search-form"
      >
        <label class="label-sign" />
        <Form-item class="width-48" label="客户名称:">
          <Input v-model="formObj.checkPlanPurpose" placeholder="请输入客户名称" @on-enter="_page" ></Input>
        </Form-item>
        <Form-item class="search-btn">
          <Button type="primary" @click="_formSearch">
            搜索
          </Button>
        </Form-item>
      </Form>
      </Col>
      <!--按钮-->
      <Col span="24" />
      <!--       <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />-->
      <el-button type="success" style="margin-bottom: 5px;margin-left: 5px;" @click="_add">
        添加
      </el-button>
      </Col>
      <!--table-->
      <Col span="24" />
      <element-table
        ref="pageTable"
        :page-columns="pageColumns"
        :table-height="tableHeight"
        :get-page="getPage"
        :opt-col-width="80"
        :click="true"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.key"
          show-overflow-tooltip
          sortable
          :prop="item.key"
          :label="item.title"
          :width="item.width"
          :min-width="200"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <div v-if="item.dateTime">
              {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}
            </div>
            <div v-if="item.key==='status'">
              <div v-if="scope.row.status===0" class="green-color">
                草稿
              </div>
              <div v-else-if="scope.row.status===10" class="green-color">
                审批中
              </div>
              <div v-else-if="scope.row.status===12" class="green-color">
                审批驳回
              </div>
              <div v-else-if="scope.row.status===1" class="green-color">
                待实施
              </div>
            </div>
            <span v-else-if="item.type" class="blue-color">
              {{ scope.row[item.key] === undefined ? '': scope.row[item.key].display }}
            </span>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
      </element-table>
      </Col>
    </Row>
    <!--添加-->
    <LeftEdit ref="editModal" @on-result-change="_page" />
  </div>
</template>
<script>
import { customerInvestigate } from '../../../api'
import LeftEdit from './LeftEdit'

export default {
  components: { LeftEdit },
  data() {
    return {
      formObj: {
        customerName: ''
      },
      selectData: [],
      searchOpen: true,
      btn: [],
      pageColumns: [
        { title: '客户名称', key: 'customerName', width: 160, detail: true },
        { title: '联系人', key: 'customerContact', width: 160 },
        { title: '地址', key: 'customerAddress', width: 160 },
        { title: '电话', key: 'customerTel', width: 160 },
        { title: '填表日期', key: 'registerTime', width: 160, date: true },
        { title: '服务项目', key: 'serviceItems', width: 160 },
        { title: '备注', key: 'remark', width: 160 }
      ],
      getPage: {},
      iconMsg: [
        // { type: 'pt-a-edit', id: '', name: '编辑' },
        // { type: 'pt-a-trash', id: '', name: '删除' }
      ],
      iconMsgDis: [
        { type: 'pt-a-edit', id: '', name: '编辑' },
        { type: 'pt-a-trash', id: '', name: '删除', disabled: true }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search') - 60
      } else {
        return this.$tableHeight('noSearch') - 60
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await customerInvestigate.page(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _searchParams(formId) {
      return this.$refs.pageTable._searchParams(formId)
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _add() {
      this.$refs.editModal._open()
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'selectIds':
          this.$emit('on-result-change', data)
          break
        case 'click':
          this.$emit('on-result-change', data.id)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
        case '删除':
          this._deleteById(data.id)
          break
      }
    },
    _open() {
      this._page()
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该信息？',
        onOk: () => {
          this._delOk(id)
        }
      })
    },
    _delOk: async function(id) {
      const result = await customerInvestigate.deleteById(id)
      if (result) {
        this.$Message.success('删除成功')
        this._page()
      }
    },
    _editModal: async function(id) {
      const result = await customerInvestigate.getById(id)
      if (result) {
        this.$refs.editModal._open(result)
      }
    }
  }
}
</script>
